<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType.toLowerCase() == 'hidden'"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div class="radio-vertical" v-if="field.mobile&&field.hiddenValue">
        <div class="titleName" v-if="field.showFieldTitle || field.showfieldtitle == 'true'">
          {{field.discript?field.discript:field.name}}
        </div>
        <div class="view-li">
          <div class="view-li-right">
            {{field.hiddenValue}}
          </div>
        </div>
      </div>
    </template>

    <!--只读-->
    <template v-else-if="field.textType.toLowerCase() == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template v-if="field.readOnlyShowValOnly">
        <!-- 只读（文本模式） -->
        <!-- <span :id="field.name_show">{{field.value}}</span>
        <span
          :id="field.divId"
          :fieldType="field.formField"
          :data-label="field.name"
          :name="'span_'+field.name"
          :discript="field.discript"
          style="display:none"
        >
          <label
            v-for="options in field.options"
            :key="options.value"
            class="checkbox-inline obpm-checkbox"
          >
            <input
              :text="options.option"
              type="checkbox"
              :value="options.value"
              :name="field.name"
              :class="field.cssClass"
              class="checkboxWid"
              :isRefreshOnChanged="field.refreshOnChanged"
              disabled
              v-model="value"
            >
            <span class="displayi-b">{{options.option}}</span>
          </label>
        </span> -->
        <div :class="[field.layout == 'vertical'?'radio-vertical':'check-horizontal']" v-if="field.mobile ">
          <div class="titleName" v-if="field.showFieldTitle || field.showfieldtitle == 'true'">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <div>
            <a class="mint-cell">
              <div class="mint-cell-left"></div> 
              <div class="mint-cell-wrapper">
                <div class="mint-cell-title">
                  <span class="mint-checkbox-label">{{field.checkShowValue}}</span>
                </div> 
              </div> 
            </a>
          </div> 
        </div>
      </template>
      <template v-else>
        <!-- 只读（控件模式） -->
        <div :class="[field.layout == 'vertical'?'radio-vertical':'check-horizontal']" v-if="field.mobile">
          <div class="titleName" v-if="field.showFieldTitle || field.showfieldtitle == 'true'">
            {{field.discript?field.discript:field.name}}
            <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
          </div>
          <div>
            <a class="mint-cell" v-for="(item, index) in field.options" :key="index">
              <!----> 
              <div class="mint-cell-left"></div> 
              <div class="mint-cell-wrapper">
                <div class="mint-cell-title">
                  <!----> 
                  <label class="mint-checklist-label">
                    <span class="mint-checkbox">
                      <input 
                        disabled
                        type="checkbox" 
                        class="mint-checkbox-input" 
                        @change="onChange"
                        v-model="field.checkValue" 
                        :value="item.value"> 
                      <span class="mint-checkbox-core"></span>
                    </span> 
                    <span class="mint-checkbox-label">{{item.option}}</span>
                  </label>
                </div> 
                <div class="mint-cell-value"><span></span></div> 
                <!---->
              </div> 
              <div class="mint-cell-right"></div>
            </a>
          </div> 
        </div>
      </template>
    </template>
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <!--垂直 (showFieldTitle field.showfieldtitle 4.4和5.0不同)-->
      <div :class="[field.layout == 'vertical'?'radio-vertical':'check-horizontal']" v-if="field.mobile" >
        <div class="titleName" v-if="field.showFieldTitle || field.showfieldtitle == 'true'">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div :class="{instantVerification: isActive}">
          <div class="radio-box">
            <a class="mint-cell" v-for="(item, index) in field.options" :key="index">
              <div class="mint-cell-left"></div> 
              <div class="mint-cell-wrapper">
                <div class="mint-cell-title">
                  <label class="mint-checklist-label">
                    <span class="mint-checkbox">
                      <input 
                        type="checkbox" 
                        class="mint-checkbox-input" 
                        @change="onChange"
                        v-model="field.checkValue" 
                        :value="item.value"> 
                      <span class="mint-checkbox-core"></span>
                    </span> 
                    <span class="mint-checkbox-label">{{item.option}}</span>
                  </label>
                </div> 
                <div class="mint-cell-value"><span></span></div> 
                <!---->
              </div> 
              <div class="mint-cell-right"></div>
            </a>
          </div> 
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
        </div>
      </div>
      
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js";
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-checkbox",
  props: ["id"],
  computed: {
    field: function() {
      let allData = this.$parent.findField(this.id);
      if(allData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(allData.discript.charAt(allData.discript.length - 1) == "*") {
          // allData.discript = allData.discript.replace(/(\s|\*)+$/g, '');
          allData.discript = allData.discript.substr(0, allData.discript.length - 1)
          allData.essential = true;
        }
      }
      if(allData.textType == 'readonly' || allData.displayType == 1 || allData.displayType == 4) {
        for(let i=0; i<allData.options.length; i++) {
          allData.options[i].disabled = true
        }
      }
      //allData.options = JSON.parse(JSON.stringify(allData.options).replace(/option/g,"label"));
      allData.value = allData.value.replace(/^(\s|;)+|(\s|;)+$/g, '')
      if(allData.value) {
        let checkReallyArray = allData.checkValue = allData.value.split(";")
        let checkShowValue = "";
        for(let i=0; i<checkReallyArray.length; i++) {
            for(let j=0; j<allData.options.length; j++) {
              if(checkReallyArray[i] == allData.options[j].value) {
                checkShowValue += allData.options[j].option + ';'
              }
            }
          }
        allData.checkShowValue = checkShowValue.replace(/^(\s|;)+|(\s|;)+$/g, '')
      }else {
        allData.checkValue = []
      }
      if(allData.options && allData.options.length) {
        let checkShowValue = "";
        for(let i=0; i<allData.options.length; i++) {
          if(allData.options[i].def) {
            checkShowValue += options[i].option + ';'
            allData.options[i].def = false
            allData.checkValue.push(allData.options[i].value)
          }
        }
        if(!allData.checkShowValue) {
          allData.checkShowValue = checkShowValue.replace(/^(\s|;)+|(\s|;)+$/g, '')
        }
        
      }
      console.log("allData.checkShowValue-->",allData.checkShowValue)
      return allData;
    },
    // value: {
    //   get: function(newValue) {
 
    //     return (this.field.value).split(";");
    //   },
    //   set: function(newValue) {
 
    //     let val = newValue.join(";");
    //     this.field.value = val;

    //   }
    // }
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  methods: {
    onChange() {
      //formData.userName = name.replace(/^(\s|;)+|(\s|;)+$/g, '');
      let checklist = this.field.checkValue
      let val = '';
      for(let i=0; i<checklist.length; i++) {
        val += checklist[i] + ";"
      }
      this.field.value = val;
      
      if(this.field.instantValidate) {
        this.isFieldClear = false;
        let value = true;
        let formData = this.$parent.checkData(value);
        //item[this.field.name] = this.field.value;
        this.$api.formValidation(
          this.$root.appid, 
          formData,
          {
            onSucess: response => {
              if(response.data.errcode == 4001) {
                if(response.data.errors && response.data.errors.length > 0) {
                  let arr = response.data.errors;
                  for(let i=0; i<arr.length; i++) {
                    if(this.field.name == arr[i].field) {
                      this.isActive = true;
                      this.errorMessage = arr[i].errmsg
                      return;
                    }else {
                      this.isActive = false;
                      this.errorMessage = '';
                    }
                  }
                }
              }else if(response.data.errcode == 0) {
                this.isActive = false;
              }
            }
          }
        )
      } 
   
      if (this.field.refreshOnChanged) {//判断是否需要刷新
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + "'"+ this.id +"'" + ')';
            eval(path);
            break
          }
        }
        // this.$parent.refresh(this.id);
      }
    },
  },
  data: function() {
    return { 
      Constant, 
      selectedOption: {},
      vertical:'input-vertical',
      checkVal:["33","44"],
      isActive:false,
      errorMessage:'',
    };
  }
};
</script>